/*
 *	File:	scale832.c
 *
 *	Implements T800 32 bit floating point scaling function used by other
 *	functions in the math library.
 *
 *	Based on INMOS supplied code.
 */

void
_scalef(float *x,float y,int n)
	{
	#pragma	asm
;
;	void	_scalef(x, y, n)
;	float	*x;
;	float	y;
;	int	n;
;
	ajw	-3
	ldl	5
	ldl	4
	stnl	0
	ldl	6
	stl	2
L1:	ldl	2
	cj	@L6
	ldl	2
	.ldc	126
	gt
	cj	@L2
	.ldc	253
	.ldc	0
	.ldc	9
	lshr
	stl	0
	stl	1
	ldl	2
	adc	-126
	stl	2
	j	@L4
L2:	.ldc	-126
	ldl	2
	gt
	cj	@L3
	.ldc	1
	.ldc	0
	.ldc	9
	lshr
	stl	0
	stl	1
	ldl	2
	adc	126
	stl	2
	j	@L4
L3:	ldl	2
	adc	127
	.ldc	0
	.ldc	9
	lshr
	stl	0
	stl	1
	.ldc	0
	stl	2
L4:	ldl	4
	ldlp	0
	fpldnlsn
	fpldnlmulsn
	ldl	4
	fpstnlsn
	j	@L1
L6:	ajw	3
	#pragma	endasm
	}
