/*
 *	t4fp64l.c
 *
 *	Contains the T414 helper functions needed by the 64 bit software
 *	floating point library routines and not already contained in
 *	"t4fp64.c".  Most functions removed from applicable spots in INMOS
 *	D700D libraries.  No optimization of OCCAM generated code undertaken
 *	(someday...)!
 *
 *	Particular thanks to Scott Lloyd of CSA for first pass decompilation
 *	chores!
 */

void
_lib_dummy(void)			/* Needed to force portable call seq */
	{
	#pragma	asm
	.ext	_r64op			;Used by some of the routines
;
;	void _fdiv64(int r[2], int x[2], int y[2])
;
	.align
D00A1:	.dw	0x00000000
	.dw	0x80000000
D00A2:	.dw	0x00000000
	.dw	0x00000000
	.pub	_fdiv64
_fdiv64:
	ajw	-30
	ldl	32
	stl	22
	ldl	33
	stl	21
	.ldc	0
	ldl	22
	ldnl	1
	gt
	cj	@L006
	.ldc	0
	.ldc	0
	ldl	32
	ldnl	0
	ldiff
	stl	25
	.ldc	0
	ldl	32
	ldnl	1
	lsub
	stl	26
	j	@L007
L006:	ldl	32
	ldlp	25
	.ldc	8
	move
L007:	.ldc	0
	ldl	21
	ldnl	1
	gt
	cj	@L008
	.ldc	0
	.ldc	0
	ldl	33
	ldnl	0
	ldiff
	stl	23
	.ldc	0
	ldl	33
	ldnl	1
	ldiff
	stl	24
	j	@L009
L008:	ldl	33
	ldlp	23
	.ldc	8
	move
L009:	ldlp	25
	stl	16
	ldl	16
	ldnl	0
	.ldc	1
	and
	eqc	1
	cj	@L0010
	.ldc	D00A1
	ldlp	14
	.ldc	8
	move
	j	@L0011
L0010:	.ldc	D00A2
	ldlp	14
	.ldc	8
	move
L0011:	ldl	16
	ldnl	1
	ldl	16
	ldnl	0
	.ldc	1
	lshr
	ldl	16
	stnl	0
	ldl	16
	stnl	1
	ldl	16
	stl	13
	ldlp	14
	stl	12
	ldlp	23
	stl	11
	ldlp	17
	stl	10
	ldlp	19
	stl	9
	ldl	11
	ldnl	1
	eqc	0
	cj	@L0012
	ldl	13
	ldnl	0
	ldl	12
	ldnl	1
	ldl	11
	ldnl	0
	ldiv
	ldl	10
	stnl	1
	stl	8
	ldl	8
	.ldc	0
	ldl	11
	ldnl	0
	ldiv
	ldl	10
	stnl	0
	ldl	9
	stnl	0
	.ldc	0
	ldl	9
	stnl	1
	j	@L0013
L0012:	ldl	11
	ldnl	1
	ldl	11
	ldnl	0
	norm
	stl	5
	stl	6
	stl	4
	ldl	13
	ldnl	1
	ldl	13
	ldnl	0
	ldl	4
	lshl
	stl	1
	stl	8
	ldl	13
	ldnl	0
	ldl	12
	ldnl	1
	ldl	4
	lshl
	stl	2
	stl	7
	.ldc	0
	stl	3
	ldlp	2
	stl	0
	ldlp	5
	stl	1
	ldlp	7
	ldlp	8
	ldl	10
	ldnlp	1
	call	@P001
	ldlp	3
	stl	0
	ldlp	5
	stl	1
	ldlp	2
	ldlp	7
	ldl	10
	call	@P001
	ldl	2
	ldl	3
	ldl	4
	lshr
	ldl	9
	stnl	0
	ldl	9
	stnl	1
L0013:	ldl	20
	ldl	19
	.ldc	1
	lshl
	stl	15
	stl	16
	ldl	15
	stl	19
	ldl	16
	stl	20
	ldlp	19
	stl	16
	.ldc	0
	ldl	16
	ldnl	1
	gt
	cj	@L0014
	.ldc	0
	ldl	17
	.ldc	1
	lsum
	stl	14
	ldl	18
	.ldc	0
	ladd
	stl	15
	ldl	14
	stl	17
	ldl	15
	stl	18
	j	@L0018
L0014:	ldlp	17
	stl	16
	ldl	20
	ldl	24
	gt
	eqc	0
	cj	@L0016
	ldl	20
	ldl	24
	diff
	eqc	0
	cj	@L0015
	ldl	19
	mint
	xor
	ldl	23
	mint
	xor
	gt
L0015:	eqc	0
L0016:	cj	@L0017
	ldl	19
	ldl	23
	diff
	ldl	20
	ldl	24
	diff
	or
	eqc	0
	cj	@L0018
	ldl	16
	ldnl	0
	.ldc	1
	and
	eqc	1
	cj	@L0018
L0017:	ldl	16
	stl	15
	.ldc	0
	ldl	15
	ldnl	0
	.ldc	1
	lsum
	stl	13
	ldl	15
	ldnl	1
	.ldc	0
	ladd
	stl	14
	ldlp	13
	ldl	15
	.ldc	8
	move
L0018:	.ldc	0
	ldl	22
	ldnl	1
	ldl	21
	ldnl	1
	xor
	gt
	cj	@L0021
	.ldc	0
	.ldc	0
	ldl	17
	ldiff
	stl	27
	.ldc	0
	ldl	18
	ldiff
	stl	28
	j	@L0022
L0021:	ldl	17
	stl	27
	ldl	18
	stl	28
L0022:	ldlp	27
	ldl	31
	.ldc	8
	move
	ajw	30
	ret

P001:	ajw	-7
	ldl	12
	ldnl	1
	ldl	9
	ldnl	0
	diff
	eqc	0
	cj	@L001
	.ldc	-1
	stl	6
	ldl	9
	ldnl	0
	ldl	10
	ldnl	0
	sum
	stl	5
	j	@L002
L001:	ldl	9
	ldnl	0
	ldl	10
	ldnl	0
	ldl	12
	ldnl	1
	ldiv
	stl	6
	stl	5
L002:	ldl	6
	cj	@L004
	.ldc	0
	ldl	12
	ldnl	0
	ldl	6
	lmul
	stl	0
	stl	1
	.ldc	0
	ldl	0
	ldl	11
	ldnl	0
	ldiff
	stl	3
	stl	4
	ldl	4
	ldl	1
	ldl	5
	ldiff
	stl	3
	stl	4
	ldl	4
	eqc	0
	cj	@L003
	ldl	6
	.ldc	1
	diff
	stl	6
L003:	ldl	1
	ldl	12
	ldnl	1
	ldl	6
	lmul
	stl	1
	stl	2
	.ldc	0
	ldl	11
	ldnl	0
	ldl	0
	ldiff
	ldl	11
	stnl	0
	stl	4
	ldl	4
	ldl	10
	ldnl	0
	ldl	1
	ldiff
	ldl	10
	stnl	0
	stl	4
	ldl	4
	ldl	9
	ldnl	0
	ldl	2
	ldiff
	ldl	9
	stnl	0
	stl	4
	ldl	4
	cj	@L004
	ldl	6
	.ldc	1
	diff
	stl	6
	.ldc	0
	ldl	12
	ldnl	0
	ldl	11
	ldnl	0
	lsum
	ldl	11
	stnl	0
	stl	4
	ldl	4
	ldl	12
	ldnl	1
	ldl	10
	ldnl	0
	lsum
	ldl	10
	stnl	0
	stl	4
	ldl	4
	.ldc	0
	ldl	9
	ldnl	0
	lsum
	ldl	9
	stnl	0
	stl	4
L004:	ldl	6
	ldl	8
	stnl	0
	ajw	7
	ret
;
;	void _fix64(int r[2], double *x)
;
	.align
D01A1:	.dw	0x00000000
	.dw	0x00000000
	.pub	_fix64
_fix64:	ajw	-15
	.ldc	D01A1
	stl	14
	ldl	17
	ldlp	10
	.ldc	8
	move
	ldlp	10
	stl	9
	ldl	9
	ldnl	1
	.ldc	1
	shl
	.ldc	21
	shr
	stl	8
	.ldc	959
	ldl	8
	gt
	cj	@L011
	.ldc	0
	stl	12
	.ldc	0
	stl	13
	j	@L019
L011:	ldl	9
	stl	5
	ldl	5
	ldnl	1
	ldl	5
	ldnl	0
	.ldc	11
	lshl
	stl	6
	stl	7
	ldlp	6
	stl	5
	ldl	5
	ldnl	1
	mint
	or
	ldl	5
	stnl	1
	.ldc	1023
	ldl	8
	diff
	stl	5
	ldl	5
	.ldc	11
	gt
	eqc	0
	cj	@L012
	ldl	7
	ldl	6
	ldl	5
	lshr
	stl	12
	stl	13
	j	@L016
L012:	ldl	14
	stl	0
	ldl	5
	stl	1
	ldlp	6
	ldlp	3
	ldlp	12
	call	@_shr64
	ldl	3
	stl	6
	ldl	4
	stl	7
	ldlp	6
	stl	4
	ldlp	12
	stl	3
	.ldc	0
	ldl	4
	ldnl	1
	gt
	eqc	0
	cj	@L013
	j	@L016
L013:	ldl	4
	ldnl	1
	mint
	diff
	eqc	0
	cj	@L014
	ldl	4
	ldnl	0
	eqc	0
	cj	@L014
	ldl	3
	ldnl	0
	.ldc	1
	and
	eqc	1
	cj	@L016
L014:	ldl	3
	stl	2
	.ldc	0
	ldl	2
	ldnl	0
	.ldc	1
	lsum
	stl	0
	ldl	2
	ldnl	1
	.ldc	0
	ladd
	stl	1
	ldlp	0
	ldl	2
	.ldc	8
	move
L016:	.ldc	0
	ldl	9
	ldnl	1
	gt
	cj	@L019
	.ldc	0
	.ldc	0
	ldl	12
	ldiff
	stl	4
	.ldc	0
	ldl	13
	lsub
	stl	5
	ldl	4
	stl	12
	ldl	5
	stl	13
L019:	ldlp	12
	ldl	16
	.ldc	8
	move
	ajw	15
	ret
;
;	void _fmul64(int r[2], int x[2], int y[2])
;
	.pub	_fmul64
_fmul64:
	ajw	-16
	ldl	18
	stl	12
	ldl	19
	stl	11
	ldl	18
	stl	6
	ldl	19
	stl	5
	ldlp	9
	stl	4
	ldlp	7
	stl	3
	.ldc	0
	ldl	5
	ldnl	0
	ldl	6
	ldnl	0
	lmul
	ldl	3
	stnl	0
	stl	2
	ldl	2
	ldl	5
	ldnl	0
	ldl	6
	ldnl	1
	lmul
	stl	2
	stl	1
	ldl	2
	ldl	5
	ldnl	1
	ldl	6
	ldnl	0
	lmul
	ldl	3
	stnl	1
	stl	2
	ldl	2
	ldl	5
	ldnl	1
	ldl	6
	ldnl	1
	lmul
	stl	2
	stl	0
	.ldc	0
	ldl	1
	ldl	2
	lsum
	ldl	4
	stnl	0
	stl	2
	ldl	2
	.ldc	0
	ldl	0
	lsum
	ldl	4
	stnl	1
	stl	2
	.ldc	0
	ldl	12
	ldnl	1
	gt
	cj	@L021
	.ldc	0
	ldl	9
	ldl	19
	ldnl	0
	ldiff
	stl	5
	ldl	10
	ldl	19
	ldnl	1
	ldiff
	stl	6
	ldl	5
	stl	9
	ldl	6
	stl	10
L021:	.ldc	0
	ldl	11
	ldnl	1
	gt
	cj	@L022
	.ldc	0
	ldl	9
	ldl	18
	ldnl	0
	ldiff
	stl	5
	ldl	10
	ldl	18
	ldnl	1
	ldiff
	stl	6
	ldl	5
	stl	9
	ldl	6
	stl	10
L022:	ldlp	9
	stl	6
	ldlp	7
	stl	5
	ldl	6
	ldnl	1
	ldl	6
	ldnl	0
	.ldc	1
	lshl
	stl	4
	ldl	6
	stnl	1
	ldl	6
	ldnl	0
	ldl	5
	ldnl	1
	.ldc	1
	lshl
	stl	4
	ldl	6
	stnl	0
	ldl	5
	ldnl	1
	ldl	5
	ldnl	0
	.ldc	1
	lshl
	ldl	5
	stnl	0
	ldl	5
	stnl	1
	ldlp	9
	stl	6
	ldlp	7
	stl	5
	.ldc	0
	ldl	5
	ldnl	1
	gt
	eqc	0
	cj	@L023
	ldl	6
	stl	4
	ldl	4
	ldlp	13
	.ldc	8
	move
	j	@L027
L023:	ldl	5
	ldnl	1
	mint
	diff
	eqc	0
	cj	@L024
	ldl	5
	ldnl	0
	eqc	0
	cj	@L024
	ldl	6
	ldnl	0
	.ldc	1
	and
	eqc	1
	cj	@L026
L024:	ldl	6
	stl	4
	.ldc	0
	ldl	4
	ldnl	0
	.ldc	1
	lsum
	stl	13
	ldl	4
	ldnl	1
	.ldc	0
	ladd
	stl	14
	j	@L027
L026:	ldl	6
	stl	4
	ldl	4
	ldlp	13
	.ldc	8
	move
L027:	ldlp	13
	ldl	17
	.ldc	8
	move
	ajw	16
	ret
;
;	void _iexp64(double *r, double *x, int n)
;
	.pub	_iexp64
_iexp64:
	ajw	-5
	ldl	7
	stl	1
	ldlp	2
	stl	0
	.ldc	0
	ldl	8
	gt
	eqc	0
	cj	@L031
	ldl	8
	.ldc	20
	shl
	ldl	1
	ldnl	1
	add
	ldl	0
	stnl	1
	j	@L032
L031:	ldl	1
	ldnl	1
	.ldc	0
	ldl	8
	diff
	.ldc	20
	shl
	diff
	ldl	0
	stnl	1
L032:	ldl	1
	ldnl	0
	ldl	0
	stnl	0
	ldlp	2
	ldl	6
	.ldc	8
	move
	ajw	5
	ret
;
;	void _norm64(int r1[2], int r2[2], int r3[2], int hi[2], int lo[2])
;
	.align
D04A1:	.dw	0x00000000
	.dw	0x00000000
	.pub	_norm64
_norm64:
	ajw	-12
	ldl	16
	stl	5
	ldl	17
	stl	4
	ldlp	9
	stl	3
	ldlp	7
	stl	2
	ldl	5
	ldnl	1
	cj	@L041
	ldl	5
	ldnl	1
	ldl	5
	ldnl	0
	norm
	stl	1
	ldl	3
	stnl	1
	stl	6
	ldl	5
	ldnl	0
	ldl	4
	ldnl	1
	ldl	6
	lshl
	stl	1
	ldl	3
	stnl	0
	ldl	4
	ldnl	1
	ldl	4
	ldnl	0
	ldl	6
	lshl
	ldl	2
	stnl	0
	ldl	2
	stnl	1
	j	@L045
L041:	ldl	5
	ldnl	0
	cj	@L042
	ldl	5
	ldnl	0
	ldl	4
	ldnl	1
	norm
	stl	1
	ldl	3
	stnl	1
	stl	6
	ldl	4
	ldnl	1
	ldl	4
	ldnl	0
	ldl	6
	lshl
	ldl	2
	stnl	1
	ldl	3
	stnl	0
	.ldc	0
	ldl	2
	stnl	0
	ldl	6
	adc	32
	stl	6
	j	@L045
L042:	ldl	4
	ldnl	1
	cj	@L043
	ldl	4
	ldnl	1
	ldl	4
	ldnl	0
	norm
	rev
	stl	1
	rev
	stl	0
	ldl	3
	stnl	0
	ldl	1
	ldl	3
	stnl	1
	ldl	0
	stl	6
	.ldc	D04A1
	ldl	2
	.ldc	8
	move
	ldl	6
	adc	64
	stl	6
	j	@L045
L043:	ldl	4
	ldnl	0
	cj	@L044
	ldl	4
	ldnl	0
	.ldc	0
	norm
	rev
	stl	1
	rev
	stl	0
	ldl	3
	stnl	0
	ldl	1
	ldl	3
	stnl	1
	ldl	0
	stl	6
	.ldc	D04A1
	ldl	2
	.ldc	8
	move
	ldl	6
	adc	96
	stl	6
	j	@L045
L044:	.ldc	D04A1
	ldl	3
	.ldc	8
	move
	.ldc	D04A1
	ldl	2
	.ldc	8
	move
	.ldc	128
	stl	6
L045:	ldl	6
	xdble
	ldl	13
	stnl	0
	ldl	13
	stnl	1
	ldlp	9
	ldl	14
	.ldc	8
	move
	ldlp	7
	ldl	15
	.ldc	8
	move
	ajw	12
	ret
;
;	void _r64f32(double *r, float x)
;
	.align
D06A1:	.dw	0x7fffffff
	.pub	_r64f32
_r64f32:
	ajw	-12
	.ldc	D06A1
	stl	11
	ldlp	9
	stl	8
	ldl	14
	stl	7
	.ldc	0
	ldl	7
	.ldc	1
	shl
	.ldc	8
	lshl
	stl	3
	stl	2
	ldl	3
	.ldc	1
	shr
	stl	3
	ldl	2
	eqc	255
	eqc	0
	cj	@L065
	ldl	2
	cj	@L061
	ldl	3
	mint
	or
	stl	5
	ldl	2
	adc	896
	stl	6
	j	@L063
L061:	ldl	2
	ldl	3
	or
	eqc	0
	cj	@L062
	.ldc	0
	stl	5
	.ldc	0
	stl	6
	j	@L063
L062:	ldl	3
	.ldc	0
	norm
	stl	4
	stl	5
	stl	1
	.ldc	1
	ldl	1
	diff
	adc	896
	stl	6
L063:	j	@L066
L065:	.ldc	2047
	stl	6
	ldl	3
	stl	5
L066:	ldl	5
	ldl	11
	ldnl	0
	and
	.ldc	0
	.ldc	11
	lshr
	stl	4
	stl	5
	ldl	6
	.ldc	0
	.ldc	12
	lshr
	stl	6
	stl	0
	ldl	5
	ldl	6
	or
	stl	5
	ldl	7
	mint
	and
	ldl	5
	or
	ldl	8
	stnl	1
	ldl	4
	ldl	8
	stnl	0
	ldlp	9
	ldl	13
	.ldc	8
	move
	ajw	12
	ret
;
;	void _r64fei(double *r, int md, int x[2])
;
	.pub	_r64fei
_r64fei:
	ajw	-13
	ldlp	10
	stl	9
	ldl	16
	stl	8
	ldl	8
	ldnl	1
	ldl	8
	ldnl	0
	or
	eqc	0
	cj	@L071
	.ldc	0
	ldl	9
	stnl	1
	.ldc	0
	ldl	9
	stnl	0
	j	@L0711
L071:	.ldc	0
	ldl	8
	ldnl	1
	gt
	cj	@L072
	mint
	stl	0
	.ldc	0
	.ldc	0
	ldl	8
	ldnl	0
	ldiff
	stl	1
	stl	7
	ldl	7
	.ldc	0
	ldl	8
	ldnl	1
	ldiff
	stl	2
	stl	7
	j	@L073
L072:	.ldc	0
	stl	0
	ldl	8
	ldnl	1
	stl	2
	ldl	8
	ldnl	0
	stl	1
L073:	ldl	2
	ldl	1
	norm
	stl	1
	stl	2
	stl	6
	.ldc	64
	ldl	6
	diff
	adc	1022
	stl	5
	ldl	2
	ldl	1
	.ldc	1
	lshl
	stl	1
	stl	2
	ldl	5
	ldl	2
	.ldc	12
	lshr
	stl	4
	stl	5
	ldl	2
	ldl	1
	.ldc	12
	lshr
	stl	3
	stl	5
	ldl	6
	.ldc	11
	gt
	cj	@L074
	j	@L078
L074:	ldl	1
	.ldc	1
	shr
	.ldc	2047
	and
	stl	1
	ldl	15
	cj	@L075
	ldl	1
	.ldc	1024
	and
	eqc	0
	cj	@L076
L075:	j	@L078
L076:	ldl	1
	.ldc	1023
	and
	ldl	3
	.ldc	1
	and
	or
	eqc	0
	cj	@L077
	j	@L078
L077:	.ldc	0
	.ldc	1
	ldl	3
	lsum
	stl	3
	stl	7
	ldl	7
	.ldc	0
	ldl	4
	lsum
	stl	4
	stl	7
L078:	ldl	0
	ldl	4
	or
	ldl	9
	stnl	1
	ldl	3
	ldl	9
	stnl	0
L0711:	ldlp	10
	ldl	14
	.ldc	8
	move
	ajw	13
	ret
;
;	float _r64t32(int md, double *x)
;
	.align
D08A1:	.dw	0x7fffff80
	.dw	0x7fffffff
	.dw	0x02000000
	.pub	_r64t32
_r64t32:
	ajw	-12
	.ldc	D08A1
	stl	11
	ldlp	10
	stl	9
	ldl	14
	stl	8
	ldl	8
	ldnl	1
	ldl	8
	ldnl	0
	.ldc	11
	lshl
	stl	6
	stl	7
	ldl	8
	ldnl	1
	.ldc	20
	shr
	.ldc	2047
	and
	stl	5
	ldl	8
	ldnl	1
	mint
	and
	stl	0
	ldl	5
	eqc	2047
	eqc	0
	cj	@L0813
	ldl	5
	cj	@L0811
	ldl	7
	mint
	or
	stl	4
	ldl	6
	stl	1
	ldl	5
	adc	-896
	stl	3
	.ldc	255
	ldl	3
	gt
	eqc	0
	cj	@L085
	ldl	13
	eqc	1
	cj	@L081
	.ldc	255
	stl	3
	mint
	stl	4
;	seterr				;A bit drastic for this "C" library
	j	@L083
L081:
;	ldl	13			;We aren't going to be this drastic
;	eqc	0
;	cj	@L082
	.ldc	254
	stl	3
	ldl	11
	ldnl	0
	stl	4
;	seterr				;A bit drastic for this "C" library
	j	@L083
;L082:	stopp
L083:	j	@L088
L085:	ldl	3
	.ldc	0
	gt
	cj	@L086
	j	@L088
L086:	ldl	3
	.ldc	-31
	gt
	cj	@L087
	ldl	1
	stl	2
	ldl	4
	.ldc	1
	ldl	3
	diff
	ldl	1
	rev
	lshr
	stl	1
	stl	4
	ldl	2
	ldl	1
	or
	stl	1
	.ldc	0
	stl	3
	j	@L088
L087:	ldl	1
	ldl	4
	or
	stl	1
	.ldc	0
	stl	4
	.ldc	0
	stl	3
L088:	j	@L0812
L0811:	.ldc	0
	stl	3
	.ldc	0
	stl	4
	ldl	7
	ldl	6
	or
	stl	1
L0812:	j	@L0815
L0813:	ldl	7
	ldl	11
	ldnl	1
	and
	stl	7
	.ldc	255
	stl	3
	ldl	7
	ldl	6
	or
	cj	@L0814
	ldl	11
	ldnl	2
	stl	4
	.ldc	0
	stl	0
	j	@L0815
L0814:	.ldc	0
	stl	4
L0815:	.ldc	255
	ldl	3
	gt
	cj	@L0822
	ldl	4
	.ldc	255
	and
	stl	2
	ldl	3
	ldl	4
	.ldc	1
	shl
	.ldc	9
	lshr
	stl	4
	stl	3
	ldl	13
	cj	@L0817
	ldl	2
	.ldc	128
	and
	eqc	0
	cj	@L0818
L0817:	j	@L0820
L0818:	ldl	2
	.ldc	127
	and
	ldl	1
	or
	ldl	4
	.ldc	1
	and
	or
	eqc	0
	cj	@L0819
	j	@L0820
L0819:	ldl	4
	adc	1
	stl	4
L0820:	j	@L0823
L0822:	ldl	3
	ldl	4
	.ldc	1
	shl
	.ldc	9
	lshr
	stl	4
	stl	3
L0823:	ldl	0
	ldl	4
	or
	ldl	9
	stnl	0
	ldl	10
	ajw	12
	ret
;
;	void _r64tei(int r[2], int md, double *x)
;
	.pub	_r64tei
_r64tei:
	ajw	-13
	ldlp	10
	stl	9
	ldl	16
	stl	8
	mint
	stl	0
	.ldc	0
	ldl	8
	ldnl	1
	ldl	0
	not
	and
	.ldc	12
	lshl
	stl	6
	stl	4
	ldl	8
	ldnl	1
	ldl	8
	ldnl	0
	.ldc	12
	lshl
	stl	2
	stl	3
	ldl	4
	eqc	2047
	cj	@L091
	j	@L0919
L091:	ldl	8
	ldnl	1
	eqc	-1008730112
	cj	@L092
	ldl	8
	ldnl	0
	eqc	0
	cj	@L092
	ldl	0
	ldl	9
	stnl	1
	.ldc	0
	ldl	9
	stnl	0
	j	@L0919
L092:	.ldc	1022
	ldl	4
	gt
	cj	@L094
	.ldc	0
	ldl	9
	stnl	1
	.ldc	0
	ldl	9
	stnl	0
	j	@L0919
L094:	.ldc	1023
	ldl	4
	gt
	cj	@L0910
	ldl	15
	cj	@L095
	ldl	3
	ldl	2
	or
	eqc	0
	cj	@L096
L095:	.ldc	0
	ldl	9
	stnl	1
	.ldc	0
	ldl	9
	stnl	0
	j	@L098
L096:	ldl	8
	ldnl	1
	ldl	0
	and
	eqc	0
	cj	@L097
	.ldc	0
	ldl	9
	stnl	1
	.ldc	1
	ldl	9
	stnl	0
	j	@L098
L097:	.ldc	-1
	ldl	9
	stnl	1
	.ldc	-1
	ldl	9
	stnl	0
L098:	j	@L0919
L0910:	ldl	8
	ldnl	1
	ldl	0
	and
	stl	1
	ldl	4
	adc	-1023
	stl	4
	.ldc	32
	ldl	4
	gt
	cj	@L0911
	ldl	2
	stl	7
	ldl	3
	stl	2
	.ldc	1
	stl	3
	.ldc	0
	stl	5
	j	@L0912
L0911:	ldl	4
	adc	-32
	stl	4
	.ldc	0
	stl	7
	.ldc	1
	stl	5
L0912:	ldl	5
	ldl	3
	ldl	4
	lshl
	stl	6
	stl	5
	ldl	3
	ldl	2
	ldl	4
	lshl
	stl	6
	stl	3
	ldl	2
	ldl	7
	ldl	4
	lshl
	stl	7
	stl	2
	ldl	15
	cj	@L0913
	ldl	2
	ldl	0
	and
	eqc	0
	cj	@L0914
L0913:	j	@L0916
L0914:	ldl	2
	ldl	0
	not
	and
	ldl	7
	or
	ldl	3
	.ldc	1
	and
	or
	eqc	0
	cj	@L0915
	j	@L0916
L0915:	.ldc	0
	.ldc	1
	ldl	3
	lsum
	stl	3
	stl	7
	ldl	7
	.ldc	0
	ldl	5
	lsum
	stl	5
	stl	7
L0916:	ldl	5
	ldl	0
	not
	and
	ldl	9
	stnl	1
	ldl	3
	ldl	9
	stnl	0
	ldl	1
	eqc	0
	cj	@L0918
	j	@L0919
L0918:	.ldc	0
	.ldc	0
	ldl	9
	ldnl	0
	ldiff
	ldl	9
	stnl	0
	stl	7
	ldl	7
	.ldc	0
	ldl	9
	ldnl	1
	ldiff
	ldl	9
	stnl	1
	stl	7
L0919:	ldlp	10
	ldl	14
	.ldc	8
	move
	ajw	13
	ret
;
;	void _ras64(double *r, double *x, double *xsqr)
;
	.align
D10A1:	.dw	0xaaef4fff
	.dw	0xff9766ad
	.dw	0x9ce81c2b
	.dw	0x009fed5e
	.pub	_ras64
_ras64:	ajw	-12
	.ldc	D10A1
	stl	11
	ldl	15
	ldlp	7
	.ldc	8
	move
	ldl	7
	ldl	8
	or
	eqc	0
	cj	@L101
	ldl	14
	ldlp	9
	call	@_fix64
	ldlp	9
	ldlp	9
	ldlp	5
	call	@_fmul64
	ldl	5
	stl	9
	ldl	6
	stl	10
	j	@L102
L101:	ldl	15
	ldlp	9
	call	@_fix64
L102:	ldl	11
	ldlp	9
	ldlp	7
	call	@_fmul64
	.ldc	0
	ldl	7
	.ldc	2036193893
	lsum
	stl	3
	ldl	8
	.ldc	62553861
	ladd
	stl	4
	ldlp	3
	ldlp	9
	ldlp	5
	call	@_fmul64
	.ldc	0
	ldl	5
	.ldc	1785800825
	lsum
	stl	3
	ldl	6
	.ldc	-140746162
	ladd
	stl	4
	ldlp	3
	ldlp	9
	ldlp	7
	call	@_fmul64
	.ldc	0
	ldl	7
	.ldc	1431306784
	lsum
	stl	3
	ldl	8
	.ldc	89478485
	ladd
	stl	4
	ldlp	3
	ldlp	9
	ldlp	5
	call	@_fmul64
	ldl	11
	ldnlp	2
	ldlp	9
	ldlp	7
	call	@_fmul64
	.ldc	0
	ldl	7
	.ldc	1999384849
	lsum
	stl	1
	ldl	8
	.ldc	-172198039
	ladd
	stl	2
	ldlp	1
	ldlp	9
	ldlp	3
	call	@_fmul64
	.ldc	0
	ldl	3
	.ldc	-287829710
	lsum
	stl	1
	ldl	4
	.ldc	720249457
	ladd
	stl	2
	ldlp	1
	ldlp	9
	ldlp	7
	call	@_fmul64
	.ldc	0
	ldl	7
	.ldc	208193837
	lsum
	stl	1
	ldl	8
	.ldc	-1086068880
	ladd
	stl	2
	ldlp	1
	ldlp	9
	ldlp	3
	call	@_fmul64
	ldl	3
	stl	1
	.ldc	0
	ldl	4
	.ldc	536870912
	ladd
	stl	2
	ldlp	1
	ldlp	5
	ldlp	7
	call	@_fdiv64
	ldlp	7
	ldlp	5
	call	@_refl64
	ldlp	5
	stl	0
	.ldc	2
	ldl	14
	ldlp	7
	call	@_r64op
	ldlp	7
	stl	0
	.ldc	0
	ldl	14
	ldl	13
	call	@_r64op
	ajw	12
	ret
;
;	void _refl64(double *r, int x[2])
;
	.pub	_refl64
_refl64:
	ajw	-12
	ldl	14
	stl	8
	.ldc	0
	stl	7
	.ldc	0
	ldl	8
	ldnl	1
	gt
	stl	7
	ldl	14
	ldnl	0
	ldl	14
	ldnl	1
	or
	eqc	0
	cj	@L111
	.ldc	0
	stl	9
	.ldc	0
	stl	10
	j	@L1110
L111:	ldlp	9
	stl	6
	ldl	7
	cj	@L112
	.ldc	0
	.ldc	0
	ldl	14
	ldnl	0
	ldiff
	ldl	6
	stnl	0
	.ldc	0
	ldl	14
	ldnl	1
	lsub
	ldl	6
	stnl	1
	j	@L113
L112:	ldl	14
	ldl	6
	.ldc	8
	move
L113:	ldl	6
	stl	5
	ldl	5
	ldnl	1
	ldl	5
	ldnl	0
	norm
	rev
	stl	3
	rev
	stl	2
	ldl	5
	stnl	0
	ldl	3
	ldl	5
	stnl	1
	ldl	2
	stl	4
	.ldc	11
	ldl	4
	gt
	cj	@L118
	ldl	5
	ldnl	0
	.ldc	0
	.ldc	11
	lshr
	stl	3
	stl	2
	ldl	5
	ldnl	1
	.ldc	1
	shl
	.ldc	1
	shr
	ldl	5
	ldnl	0
	.ldc	11
	lshr
	ldl	5
	stnl	0
	ldl	5
	stnl	1
	.ldc	1023
	ldl	4
	diff
	.ldc	20
	shl
	ldl	5
	ldnl	1
	or
	ldl	5
	stnl	1
	.ldc	0
	ldl	3
	gt
	eqc	0
	cj	@L114
	j	@L116
L114:	ldl	3
	mint
	diff
	eqc	0
	cj	@L115
	ldl	5
	ldnl	0
	.ldc	1
	and
	eqc	1
	cj	@L116
L115:	ldl	5
	stl	2
	.ldc	0
	ldl	2
	ldnl	0
	.ldc	1
	lsum
	stl	0
	ldl	2
	ldnl	1
	.ldc	0
	ladd
	stl	1
	ldlp	0
	ldl	2
	.ldc	8
	move
L116:	j	@L119
L118:	ldl	5
	ldnl	1
	.ldc	1
	shl
	.ldc	1
	shr
	ldl	5
	ldnl	0
	.ldc	11
	lshr
	ldl	5
	stnl	0
	ldl	5
	stnl	1
	.ldc	1023
	ldl	4
	diff
	.ldc	20
	shl
	ldl	5
	ldnl	1
	or
	ldl	5
	stnl	1
L119:	ldl	7
	cj	@L1110
	ldl	5
	ldnl	1
	mint
	or
	ldl	5
	stnl	1
L1110:	ldlp	9
	ldl	13
	.ldc	8
	move
	ajw	12
	ret
;
;	void _rex64(double *r, double *x)
;
	.align
D12A1:	.dw	0x652b82fe
	.dw	0x3ff71547
	.dw	0x00000000
	.dw	0x3fe63000
	.dw	0x5c610ca8
	.dw	0xbf2bd010
	.dw	0x237ac6e2
	.dw	0x00008a95
	.dw	0x6fde3807
	.dw	0x00103f99
	.pub	_rex64
_rex64:	ajw	-21
	.ldc	D12A1
	stl	20
	ldl	20
	stl	0
	.ldc	2
	ldl	23
	ldlp	14
	call	@_r64op
	ldlp	14
	.ldc	1
	ldlp	16
	call	@_r64tei
	ldlp	16
	.ldc	1
	ldlp	14
	call	@_r64fei
	ldl	20
	ldnlp	2
	stl	0
	.ldc	2
	ldlp	14
	ldlp	10
	call	@_r64op
	ldlp	10
	stl	0
	.ldc	1
	ldl	23
	ldlp	8
	call	@_r64op
	ldl	20
	ldnlp	4
	stl	0
	.ldc	2
	ldlp	14
	ldlp	10
	call	@_r64op
	ldlp	10
	stl	0
	.ldc	1
	ldlp	8
	ldlp	12
	call	@_r64op
	ldlp	12
	ldlp	10
	call	@_fix64
	ldlp	10
	ldlp	10
	ldlp	8
	call	@_fmul64
	ldl	20
	ldnlp	6
	ldlp	8
	ldlp	4
	call	@_fmul64
	.ldc	0
	ldl	4
	.ldc	2107619073
	lsum
	stl	0
	ldl	5
	.ldc	14911267
	ladd
	stl	1
	ldlp	0
	ldlp	8
	ldlp	2
	call	@_fmul64
	.ldc	0
	ldl	2
	.ldc	-65
	lsum
	stl	4
	ldl	3
	.ldc	536870911
	ladd
	stl	5
	ldlp	4
	ldlp	10
	ldlp	6
	call	@_fmul64
	ldl	6
	stl	10
	ldl	7
	stl	11
	ldl	20
	ldnlp	8
	ldlp	8
	ldlp	6
	call	@_fmul64
	.ldc	0
	ldl	6
	.ldc	1351904427
	lsum
	stl	2
	ldl	7
	.ldc	119301020
	ladd
	stl	3
	ldlp	2
	ldlp	8
	ldlp	4
	call	@_fmul64
	ldl	4
	stl	2
	.ldc	0
	ldl	5
	.ldc	1073741824
	ladd
	stl	3
	.ldc	0
	ldl	2
	ldl	10
	ldiff
	stl	4
	ldl	3
	ldl	11
	lsub
	stl	5
	ldlp	4
	ldlp	10
	ldlp	6
	call	@_fdiv64
	ldl	6
	stl	4
	.ldc	0
	ldl	7
	.ldc	1073741824
	ladd
	stl	5
	ldlp	4
	ldlp	18
	call	@_refl64
	ldlp	18
	stl	11
	ldl	11
	ldnl	0
	stl	7
	ldl	11
	ldnl	1
	.ldc	1048575
	and
	stl	8
	ldl	11
	ldnl	1
	ldl	11
	ldnl	0
	.ldc	52
	lshr
	stl	5
	stl	6
	.ldc	0
	ldl	16
	.ldc	1
	lsum
	stl	3
	ldl	17
	.ldc	0
	ladd
	stl	4
	.ldc	0
	ldl	5
	ldl	3
	lsum
	stl	1
	ldl	6
	ldl	4
	ladd
	stl	2
	ldl	2
	ldl	1
	.ldc	52
	lshl
	stl	5
	stl	6
	ldl	7
	ldl	5
	or
	stl	9
	ldl	8
	ldl	6
	or
	stl	10
	ldlp	9
	ldl	11
	.ldc	8
	move
	ldlp	18
	ldl	22
	.ldc	8
	move
	ajw	21
	ret
;
;	void _shr64(int rhi[2], int rlo[2], int hi[2], int lo[2], int n)
;
	.align
D13A1:	.dw	0x00000000
	.dw	0x00000000
	.pub	_shr64
_shr64:	ajw	-11
	ldl	14
	stl	5
	ldl	15
	stl	4
	ldlp	8
	stl	3
	ldlp	6
	stl	2
	ldl	16
	stl	1
	.ldc	32
	ldl	1
	gt
	cj	@L131
	ldl	4
	ldnl	1
	ldl	4
	ldnl	0
	ldl	1
	lshr
	ldl	2
	stnl	0
	stl	0
	ldl	5
	ldnl	0
	ldl	4
	ldnl	1
	ldl	1
	lshr
	ldl	2
	stnl	1
	stl	0
	ldl	5
	ldnl	1
	ldl	5
	ldnl	0
	ldl	1
	lshr
	ldl	3
	stnl	0
	ldl	3
	stnl	1
	j	@L135
L131:	.ldc	64
	ldl	1
	gt
	cj	@L132
	ldl	1
	adc	-32
	stl	1
	ldl	5
	ldnl	0
	ldl	4
	ldnl	1
	ldl	1
	lshr
	ldl	2
	stnl	0
	stl	0
	ldl	5
	ldnl	1
	ldl	5
	ldnl	0
	ldl	1
	lshr
	ldl	2
	stnl	1
	ldl	3
	stnl	0
	.ldc	0
	ldl	3
	stnl	1
	j	@L135
L132:	.ldc	96
	ldl	1
	gt
	cj	@L133
	ldl	5
	ldnl	1
	ldl	5
	ldnl	0
	ldl	1
	adc	-64
	lshr
	ldl	2
	stnl	0
	ldl	2
	stnl	1
	.ldc	D13A1
	ldl	3
	.ldc	8
	move
	j	@L135
L133:	.ldc	128
	ldl	1
	gt
	cj	@L134
	ldl	5
	ldnl	1
	ldl	1
	adc	-96
	shr
	ldl	2
	stnl	0
	.ldc	0
	ldl	2
	stnl	1
	.ldc	D13A1
	ldl	3
	.ldc	8
	move
	j	@L135
L134:	.ldc	D13A1
	ldl	3
	.ldc	8
	move
	.ldc	D13A1
	ldl	2
	.ldc	8
	move
L135:	ldlp	8
	ldl	12
	.ldc	8
	move
	ldlp	6
	ldl	13
	.ldc	8
	move
	ajw	11
	ret
	#pragma	endasm
	}
