/*
 *	time.h
 *
 *	Copyright 1988 by Logical Systems.
 */

#ifndef	_TIME				/* Avoid duplication */
#define	_TIME		1

#define	const				/* Not implemented yet */

#define	CLK_TCK		15625
#define	NULL		0

typedef	unsigned long	clock_t;
typedef	unsigned int	size_t;
typedef	unsigned long	time_t;

struct	tm
	{
	int	tm_sec;		/* Seconds after the minute [0-59] */
	int	tm_min;		/* Minutes after the hour [0-59] */
	int	tm_hour;	/* Hours since midnight [0-23] */
	int	tm_mday;	/* Day of month [1-31] */
	int	tm_mon;		/* Months since January [0-11] */
	int	tm_year;	/* Years since 1900 */
	int	tm_wday;	/* Days since Sunday [0-6] */
	int	tm_yday;	/* Days since January 1 [0-365] */
	int	tm_isdst;	/* Daylight Savings Time flag */
	};

char	*asctime(const struct tm *timeptr);
/*clock_t	clock(void);			*/
char	*ctime(const time_t *timer);
/*double	difftime(time_t time1, time_t time2);	*/
struct tm *gmtime(const time_t *timer);
struct tm *localtime(const time_t *timer);
/*time_t	mktime(struct tm *timeptr);	*/
time_t	time(time_t *timer);

#endif	/* _TIME */
