/*
 *	fscanf,scanf
 *
 *	Copyright (c) 1988 by Logical Systems
 *
 *	Written by Kirk Bailey
 *
 *	Last update:	3/2/88
 */

#include	<stdio.h>
#include	<stddef.h>
#include	<stdarg.h>

/*
 *	fscanf
 */
int
#ifdef	MSDOS
fscanf(fp,format)
	FILE	*fp;
	char	*format;
#else
fscanf(FILE *fp,const char *format,...)
#endif	/* MSDOS */
	{
	extern	int	_scf();

	int	rval;
	va_list	vargs;

	va_start(vargs,format);		/* Start of var args stuff */
	rval = _scf(fgetc,ungetc,fp,format,vargs);
	va_end(vargs);			/* Cleanup for var args stuff */
	return (rval);
	}

/*
 *	scanf
 */
#ifdef	MSDOS
scanf(format)
	char	*format;
#else
scanf(const char *format,...)
#endif	/* MSDOS */
	{
	extern	int	_scf();

	int	rval;
	va_list	vargs;

	va_start(vargs,format);		/* Start of var args stuff */
	rval = _scf(fgetc,ungetc,stdin,format,vargs);
	va_end(vargs);			/* Cleanup for var args stuff */
	return (rval);
	}
