/*
 *	nmstdio.h
 *
 *	Non-Macro versions of stdio routines which are normally implemented as
 *	macros.  This allows the ANSI "#undef" procedure to be used to get
 *	access to "real" functions which can have addresses taken etc.
 *
 *	Copyright 1988 by Logical Systems.
 */

#include	<stdio.h>

#undef	getc
int
getc(FILE *stream)
	{
	return (fgetc(stream));
	}

#undef	getchar
int
getchar(void)
	{
	return (fgetc(stdin));
	}

#undef	putc
int
putc(int c,FILE *stream)
	{
	return (fputc(c,stream));
	}

#undef	putchar
int
putchar(int c)
	{
	return (fputc(c,stdout));
	}
