/*
 *	File:	scale864.c
 *
 *	Implements T800 64 bit floating point scaling function used by other
 *	functions in the math library.
 *
 *	Based on INMOS supplied code.
 */

void
_scale(double *x,double y,int n)
	{
	#pragma	asm
;
;	void	_scale(x, y, n)
;	double	*x;
;	double	y;
;	int	n;
;
	ajw	-4
	.ldc	0
	stl	0
	ldl	6
	ldl	5
	.ldc	8
	move
	ldl	7
	stl	3
L1:	ldl	3
	cj	@L6
	ldl	3
	.ldc	1022
	gt
	cj	@L2
	.ldc	2045
	.ldc	0
	.ldc	12
	lshr
	stl	1
	stl	2
	ldl	3
	adc	-1022
	stl	3
	j	@L4
L2:	.ldc	-1022
	ldl	3
	gt
	cj	@L3
	.ldc	1
	.ldc	0
	.ldc	12
	lshr
	stl	1
	stl	2
	ldl	3
	adc	1022
	stl	3
	j	@L4
L3:	ldl	3
	adc	1023
	.ldc	0
	.ldc	12
	lshr
	stl	1
	stl	2
	.ldc	0
	stl	3
L4:	ldl	5
	ldlp	0
	fpldnldb
	fpldnlmuldb
	ldl	5
	fpstnldb
	j	@L1
L6:	ajw	4
	#pragma	endasm
	}
