/*
 *	setjmp.c
 *
 *	setjmp/longjump for the Transputer.
 *
 *	Copyright 1988, 1989 by Logical Systems.
 */

#include	<inline.h>
#include	<setjmp.h>

int
setjmp(jmp_buf env)
	{
	#pragma	asm
	ldlp	0
	ldl	[env]
	stnl	0			;env[0] is workspace
	ldl	0
	ldl	[env]
	stnl	1			;env[1] is return address of setjmp()
	.ldc	0			;Return value from direct invocation
	#pragma	endasm
	}

void
longjmp(jmp_buf env, int val)
	{
	#pragma asm
	ldl	[val]
	ldl	[val]
	eqc	0
	add				;"val"==0 turns into 1 by ANSI
	ldl	[env]
	ldl	[env]
	ldnl	0			;Get workspace pointer from "env[0]"
	gajw				;Set new workspace
	stl	0			;Flush garbage out of A
	ldnl	1			;New PC in A (env[1]), "val" in B
	stl	0			;Set PC in return address spot
	#pragma	endasm
	}
