/*
 *	File:	unpk832.c
 *
 *	Implements T800 32 bit floating point "unpacking" operation used by
 *	other functions in the math library.
 *
 *	Based on INMOS supplied code.
 */

void
_unpkf(int *n,float *x,float y)
	{
	#pragma	asm
;
;	void	_unpkf(n, x, y)
;	int	*n;
;	float	*x;
;	float	y;
;
	ajw	-5
	ldl	8
	.ldc	1
	shl
	stl	1
	.ldc	0
	ldl	1
	.ldc	8
	lshl
	stl	2
	stl	3
	ldl	1
	cj	@L1
	ldl	3
	eqc	255
	cj	@L2
L1:	.ldc	128
	ldl	6
	stnl	0
	.ldc	2139095041
	ldl	7
	stnl	0
	j	@L5
L2:	ldl	3
	eqc	0
	cj	@L3
	ldl	2
	.ldc	0
	norm
	stl	3
	stl	2
	stl	0
	.ldc	0
	ldl	0
	adc	127
	sub
	ldl	6
	stnl	0
	ldl	2
	.ldc	1
	shl
	stl	2
	j	@L4
L3:	ldl	3
	adc	-127
	ldl	6
	stnl	0
L4:	.ldc	127
	ldl	2
	.ldc	9
	lshr
	ldl	7
	stnl	0
	stl	3
L5:	ajw	5
	#pragma	endasm
	}
