/*
 *	File:	unpk864.c
 *
 *	Implements T800 64 bit floating point "unpacking" operation used by
 *	other functions in the math library.
 *
 *	Based on INMOS supplied code.
 */

void
_unpk(int *n,double *x,double y)
	{
	#pragma	asm
;
;	void	_unpkf(n, x, y)
;	int	*n;
;	double	*x;
;	double	*y;
;
	ajw	-5
	.ldc	0
	ldl	8
	ldnl	1
	.ldc	1
	shl
	.ldc	11
	lshl
	stl	1
	stl	2
	ldl	8
	ldnl	1
	ldl	8
	ldnl	0
	.ldc	12
	lshl
	stl	3
	stl	4
	ldl	8
	ldnl	1
	.ldc	1
	shl
	ldl	8
	ldnl	0
	or
	cj	@L1
	ldl	2
	eqc	2047
	cj	@L2
L1:	.ldc	1024
	ldl	6
	stnl	0
	.ldc	data
	ldl	7
	.ldc	8
	move
	j	@L5
	.align
data:	.dw	0x00000001
	.dw	0x7ff00000
L2:	ldl	2
	eqc	0
	cj	@L3
	ldl	4
	ldl	3
	norm
	stl	3
	stl	4
	stl	0
	.ldc	0
	ldl	0
	adc	1023
	sub
	ldl	6
	stnl	0
	ldl	4
	ldl	3
	.ldc	1
	lshl
	ldl	7
	stnl	0
	ldl	7
	stnl	1
	j	@L4
L3:	ldl	2
	adc	-1023
	ldl	6
	stnl	0
L4:	ldl	4
	ldl	3
	.ldc	12
	lshr
	ldl	7
	stnl	0
	stl	2
	.ldc	1023
	ldl	4
	.ldc	12
	lshr
	ldl	7
	stnl	1
	stl	2
L5:	ajw	5
	#pragma	endasm
	}
